## mingw-w64-libint2-2.9.0-1.src.tar.zst

=== doc/progman/Makefile ===
TOPDIR=../..
ifndef SRCDIR
  SRCDIR=$(shell pwd)
endif
TOPOBJDIR = $(shell ls -d `pwd`/$(TOPDIR))

TARGETNAME = progman
TARGET = $(TARGETNAME).$(DOCSUF)

-include $(TOPDIR)/doc/MakeVars
-include $(TOPDIR)/doc/MakeRules
include $(SRCDIR)/$(TOPDIR)/lib/MakeSuffixRules
include $(SRCDIR)/$(TOPDIR)/lib/MakeRules

pdf::

ps::

dvi::

html::

install-pdf:: pdf

install-ps:: ps

install-dvi:: dvi

install-html:: html

ifdef BIBTEX
ifdef PDFLATEX
pdf:: $(TARGETNAME).pdf

install-pdf:: pdf
	$(INSTALL) $(INSTALLDIROPT) $(DESTDIR)$(docdir)/pdf
	$(LTINST) $(INSTALL) $(INSTALLDOCOPT) $(TARGETNAME).pdf $(DESTDIR)$(docdir)/pdf

%.pdf:: $(SRCDIR)/%.tex
	TEXINPUTS=$(TEXINPUTS) $(PDFLATEX) $<
	BIBINPUTS=$(BIBINPUTS) $(BIBTEX) $(@:%.pdf=%)
	TEXINPUTS=$(TEXINPUTS) $(PDFLATEX) $<
	TEXINPUTS=$(TEXINPUTS) $(PDFLATEX) $<
	TEXINPUTS=$(TEXINPUTS) $(PDFLATEX) $<
endif

ifdef PSLATEX
ifdef DVIPS
ps:: $(TARGETNAME).ps

install-ps:: ps
	$(INSTALL) $(INSTALLDIROPT) $(DESTDIR)$(docdir)/ps
	$(LTINST) $(INSTALL) $(INSTALLDOCOPT) $(TARGETNAME).ps $(DESTDIR)$(docdir)/ps

%.ps:: $(SRCDIR)/%.tex
	TEXINPUTS=$(TEXINPUTS) $(PSLATEX) $<
	BIBINPUTS=$(BIBINPUTS) $(BIBTEX) $(@:%.ps=%)
	TEXINPUTS=$(TEXINPUTS) $(PSLATEX) $<
	TEXINPUTS=$(TEXINPUTS) $(PSLATEX) $<
	TEXINPUTS=$(TEXINPUTS) $(PSLATEX) $<
	TEXINPUTS=$(TEXINPUTS) $(DVIPS) $(@:%.ps=%)
endif
endif

ifdef LATEX
dvi:: $(TARGETNAME).dvi

install-dvi:: dvi
	$(INSTALL) $(INSTALLDIROPT) $(DESTDIR)$(docdir)/dvi
	$(LTINST) $(INSTALL) $(INSTALLDOCOPT) $(TARGETNAME).dvi $(DESTDIR)$(docdir)/dvi

%.dvi:: $(SRCDIR)/%.tex
	TEXINPUTS=$(TEXINPUTS) $(LATEX) $<
	BIBINPUTS=$(BIBINPUTS) $(BIBTEX) $(@:%.dvi=%)
	TEXINPUTS=$(TEXINPUTS) $(LATEX) $<
	TEXINPUTS=$(TEXINPUTS) $(LATEX) $<
	TEXINPUTS=$(TEXINPUTS) $(LATEX) $<

ifdef LATEX2HTML
html:: $(SRCDIR)/$(TARGETNAME).tex
	$(LATEX2HTML) $<
endif

endif

endif

distclean:: clean
	-rm -f macros.tex

=== tests/eri/Makefile ===
TOPDIR=../..
ifndef SRCDIR
  SRCDIR=$(shell pwd)
endif
-include $(TOPDIR)/tests/MakeVars

# include headers the object include directory
CPPFLAGS += -I$(TOPDIR)/include
# include headers from the compiler directory
CPPFLAGS += -I$(SRCDIR)/$(TOPDIR)/src/bin/libint
# include headers from the src/bin/test_eri directory
CPPFLAGS += -I$(SRCDIR)/$(TOPDIR)/src/bin/test_eri
# include headers from the library directory
CPPFLAGS += -I$(SRCDIR)/$(TOPDIR)/src/lib/libint
# include processed headers from the compiler directory
CPPFLAGS += -I$(TOPDIR)/src/bin/libint

COMPILER_LIB = $(TOPDIR)/src/bin/libint/libINT.a
COMPUTE_LIB = -lint2
vpath %.a $(TOPDIR)/lib:$(TOPDIR)/lib/.libs 

OBJSUF = o
DEPSUF = d
CXXDEPENDSUF = none
CXXDEPENDFLAGS = -M

TEST = test
CXXTESTSRC = $(TEST).cc
CXXTESTOBJ = $(CXXTESTSRC:%.cc=%.$(OBJSUF))
CXXTESTDEP = $(CXXTESTSRC:%.cc=%.$(DEPSUF))

check:: $(TEST)
	./$(TEST) 0 2 && ./$(TEST) 1 1 && ./$(TEST) 2 1 && ./$(TEST) 3 1 && ./$(TEST) 4 1

ifeq ($(CXX_COMPATIBLE_WITH_CXXGEN),yes)
$(TEST): $(CXXTESTOBJ) $(COMPILER_LIB) $(COMPUTE_LIB)
	$(LD) -o $@ $(CXXFLAGS) $(LDFLAGS) $^ $(SYSLIBS)
else
$(TEST):
	echo "Cannot test generated code! $(CXXGEN) is not compatible with $(CXXCOMP)"
	@exit 0
endif

# Source files for timer and tester are to be compiled using CXXGEN
$(TEST): CXX=$(CXXGEN)
$(TEST): CXXFLAGS=$(CXXGENFLAGS)
$(TEST): LD=$(CXXGEN)

clean::
	-rm -rf $(TEST) *.o *.d

distclean:: realclean

realclean:: clean

targetclean:: clean

depend:: $(CXXTESTDEP)

ifneq ($(DODEPEND),no)
ifneq ($(CXXDEPENDSUF),none)
%.d: %.cc
	$(CXXDEPEND) $(CXXDEPENDFLAGS) -c $(CPPFLAGS) $(CXXFLAGS) $< > /dev/null
	sed 's/^$*.o/$*.$(OBJSUF) $*.d/g' < $(*F).$(CXXDEPENDSUF) > $(@F)
	/bin/rm -f $(*F).$(CXXDEPENDSUF)
else
%.d: %.cc
	$(CXXDEPEND) $(CXXDEPENDFLAGS) -c $(CPPFLAGS) $(CXXFLAGS) $< | sed 's/^$*.o/$*.$(OBJSUF) $*.d/g' > $(@F)
endif

-include $(CXXTESTDEP)
endif

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=libint
pkgbase=mingw-w64-${_realname}2
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}2")
pkgver=2.9.0
pkgrel=1
pkgdesc="high-performance library for computing Gaussian integrals in quantum mechanics (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://github.com/evaleev/libint'
msys2_references=(
  'aur: libint2'
)
license=('spdx:LGPL-3.0-or-later')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-autotools"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-gmp"
             "${MINGW_PACKAGE_PREFIX}-mpfr"
             "${MINGW_PACKAGE_PREFIX}-python")
optdepends=("${MINGW_PACKAGE_PREFIX}-boost"
            "${MINGW_PACKAGE_PREFIX}-eigen3"
            "${MINGW_PACKAGE_PREFIX}-gmp"
            "${MINGW_PACKAGE_PREFIX}-mpfr")
source=("https://github.com/evaleev/libint/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        #https://github.com/evaleev/libint/releases/download/v${pkgver}/${_realname}-${pkgver}.tgz
        "001-fix-build-on-mingw.patch"
        "002-cmake-fix-build-on-mingw.patch::https://github.com/evaleev/libint/commit/7720248d.patch")
sha256sums=('4929b2f2d3e53479270be052e366e8c70fa154a7f309e5c2c23b7d394159687d'
            'd60290391aad41601495b0717c53d8b888327e6c67932d633c3e731016626f80'
            '723b3a7520bd4cce149092e5ee104aa19d61ca99ce64b52de18a7215861b3006')
noextract=("${_realname}-${pkgver}.tar.gz")

_generate_source() {
  cd "${srcdir}"
  mkdir -p generated && cd generated

  local LMAX=4
  ../${_realname}-${pkgver}/configure \
    --srcdir=../${_realname}-${pkgver} \
    --with-cxxgen-optflags="${CXXFLAGS}" \
    --enable-eri=2 \
    --enable-eri3=2 \
    --enable-eri2=2 \
    --enable-g12=1 \
    --enable-1body=2 \
    --disable-1body-property-derivs \
    --with-max-am=${LMAX} \
    --with-opt-am=3 \
    --with-eri-max-am=${LMAX},$((LMAX-1)) \
    --with-eri2-max-am=$((LMAX+2)),$((LMAX+1)) \
    --with-eri3-max-am=$((LMAX+2)),$((LMAX+1)) \
    --with-multipole-max-order=4 \
    --enable-generic-code \
    --disable-unrolling

  sed -s "s|\.\.\.|..|g" -i Makefile
  make export
}

prepare() {
  echo "Extracting ${_realname}-${pkgver}.tar.gz..."
  tar -xzf ${_realname}-${pkgver}.tar.gz || true

  cd "${srcdir}"/${_realname}-${pkgver}

  patch -p1 -i "${srcdir}"/001-fix-build-on-mingw.patch
  patch -p1 -i "${srcdir}"/002-cmake-fix-build-on-mingw.patch

  mv lib/basis/6-31g\*.g94 lib/basis/6-31gs.g94
  mv lib/basis/6-31g\*\*.g94 lib/basis/6-31gss.g94
  mv lib/basis/6-311g\*\*.g94 lib/basis/6-311gss.g94

  ./autogen.sh

  _generate_source
  cd "${srcdir}"/generated
  tar -xzf ${_realname}-${pkgver}.tgz
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DENABLE_FORTRAN=ON \
      -DENABLE_MPFR=ON \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -S generated/${_realname}-${pkgver} \
      -B build-${MSYSTEM}

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/libint2/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  # Remove some unrequired files
  find "${pkgdir}"${MINGW_PREFIX}/ -type f -name '\._*' -exec rm {} \;

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}2/LICENSE
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}2/COPYING
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING.LESSER \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}2/COPYING.LESSER
}
